﻿Public Class Form3
    #Region "Sub Form3_Load : Loadイベント."
        Private Sub Form3_Load( sender As System.Object,  e As System.EventArgs) Handles MyBase.Load
            Try
                ' カテゴリのリストを取得します.
                Dim Cls_PCC As System.Diagnostics.PerformanceCounterCategory() = ClsPub_Performance.GetCategoryList(ClsPub_ComputerName)
                ' カテゴリをリストボックスにセットします.
                With Me.Lst_CategoryList
                    .Items.Clear
                    For Each OnePCC As System.Diagnostics.PerformanceCounterCategory In Cls_PCC
                        .Items.Add(OnePCC)
                    Next
                End With
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Lst_CategoryList_SelectedIndexChanged : カテゴリの選択."
        Private Sub Lst_CategoryList_SelectedIndexChanged( sender As System.Object,  e As System.EventArgs) Handles Lst_CategoryList.SelectedIndexChanged
            Try
                ' 各コントロールの初期化.
                Me.Txt_Explanation.Text = ""    ' 説明用テキストをクリア.
                Me.Lst_Instance.Items.Clear     ' インスタンス用リストボックスをクリア.
                Me.Lst_Counter.Items.Clear      ' カウンター用リストボックスをクリア.

                ' インスタンスのリストを取得します.
                Dim Str_Instance() As String = ClsPub_Performance.GetInstanceList(CType(sender, ListBox).SelectedItem)
                ' インスタンスをリストボックスにセットします.
                With Me.Lst_Instance
                    .Items.Clear

                    If Str_Instance.Length = 0 Then
                        Lst_Instance_SelectedIndexChanged_Sub(Nothing)
                    Else
                        For Each OneInstance As String In Str_Instance
                            .Items.Add(OneInstance)
                        Next
                    End If
                End With

            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Lst_Instance_SelectedIndexChanged : インスタンスの選択."
        Private Sub Lst_Instance_SelectedIndexChanged( sender As System.Object,  e As System.EventArgs) Handles Lst_Instance.SelectedIndexChanged
            Try
                Lst_Instance_SelectedIndexChanged_Sub(CType(sender, ListBox).SelectedItem)
            Catch ex As Exception

            End Try
        End Sub

        #Region "Sub Lst_Instance_SelectedIndexChanged_Sub : インスタンスの選択(サブ)."
            Private Sub Lst_Instance_SelectedIndexChanged_Sub(ByVal StrVal_InstanceName As String)
                Try
                    Me.Txt_Explanation.Text = ""    ' 説明用テキストをクリア.
                    Me.Lst_Counter.Items.Clear      ' カウンター用リストボックスをクリア.
                    ' カウンターのリストをリストボックスにセットします.
                    With Me.Lst_Counter
                        .Items.Clear

                        If Not (Me.Lst_CategoryList.SelectedItem Is Nothing) Then
                            Dim Cls_CL As System.Diagnostics.PerformanceCounter() = Nothing
                            Cls_CL = ClsPub_Performance.GetCounterList(Me.Lst_CategoryList.SelectedItem, StrVal_InstanceName)
                            For Each OneCL As System.Diagnostics.PerformanceCounter In Cls_CL
                                If Not ClsPub_Performance.FoundCounter(OneCL) Then
                                    .Items.Add(OneCL)
                                End If
                            Next
                        End If
                    End With
                Catch ex As Exception

                End Try
            End Sub
        #End Region
        
    #End Region

    #Region "Sub Lst_Counter_SelectedIndexChanged : カウンターの選択."
        Private Sub Lst_Counter_SelectedIndexChanged( sender As System.Object,  e As System.EventArgs) Handles Lst_Counter.SelectedIndexChanged
            Try
                Me.Txt_Explanation.Text = ""    ' 説明用テキストをクリア.
                If Not (CType(sender, ListBox).SelectedItem Is Nothing) Then
                    ' 説明用テキストにセットします.
                    Me.Txt_Explanation.Text = Ctype(CType(sender, ListBox).SelectedItem, System.Diagnostics.PerformanceCounter).CounterHelp
                End If
            Catch ex As Exception

            End Try
        End Sub
    #End Region

    #Region "Sub Btn_Add_Click : パフォーマンスモニタに追加."
        Private Sub Btn_Add_Click( sender As System.Object,  e As System.EventArgs) Handles Btn_Add.Click
            Try
                With Me.Lst_Counter
                    If Not (.SelectedItem Is Nothing) Then
                        If ClsPub_Performance.AddCounter(.SelectedItem) Then
                            ' 追加したカウンターをリストから削除します.
                            .Items.Remove(.SelectedItem)
                        End If
                    End If
                End With
            Catch ex As Exception

            End Try
        End Sub
    #End Region
End Class